<!--
 * @Title: 
 * @Description: 运维公司管理员用户管理
 * @Author: swp
 * @Date: 2022-08-24 10:49:21
 * @LastEditors: 
 * @LastEditTime: 2022-08-24 10:49:21
-->
<template>
    <div>
        <el-row>
            <el-col :span="24">
                <basic-container>
                    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page"
                        :before-open="beforeOpen" ref="crud" v-model="form" :permission="permissionList" @row-del="rowDel"
                        @row-update="rowUpdate" @row-save="rowSave" @search-change="searchChange"
                        @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
                        @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad"
                        @before-open="beforeOpen" @select-change="selectChange">
                        <template slot="state" slot-scope="{ row }">
                            <el-button type="text" @click="openConfig(row)"> 正常 </el-button>
                        </template>
                        <template slot-scope="{ row, index }" slot="menu">
                        </template>
                        <template slot="state" slot-scope="{ row }">
                            <el-button type="text" @click="openConfig(row)"> 正常 </el-button>
                        </template>
                    </avue-crud>
                </basic-container>
            </el-col>
        </el-row>
    </div>
</template>

<script>

import { getPage, getDetail, add, update, remove } from "@/api/baseinfo/serviceperson.js";

export default {
    components: {

    },
    data() {
        return {
            id: "",
            editForm: {},
            editDialog: false,
            form: {},
            selectionList: [],
            query: {},
            loading: true,
            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            option: {
                labelWidth: 140,
                viewLabelWidth: 140,
                searchLabelWidth: 140,
                height: "auto",
                calcHeight: 80,
                align: "center",
                headerAlign: "center",
                tip: false,
                simplePage: true,
                searchShow: true,
                searchMenuSpan: 6,
                border: true,
                index: true,
                selection: false,
                viewBtn: false,
                viewTitle: "运维人员信息",
                editBtn: true,
                delBtn: true,
                menuWidth: 220,
                dialogType: "drawer",
                dialogClickModal: false,
                addBtnText: "新增用户",
                columnBtn: false,
                column: [
                    {
                        label: "登录帐号",
                        prop: "account",
                        span: 24,
                        tip: "密码默认为帐号+@8282",
                        tipPlacement: 'right-end',
                        editDisabled: true,
                        rules: [
                            {
                                required: true,
                                message: "请录入登录帐号",
                                trigger: "click",
                            },
                        ],
                    },
                    {
                        label: "用户名称",
                        prop: "realName",
                        search: true,
                        span: 24,
                        rules: [
                            {
                                required: true,
                                message: "请录入用户名称",
                                trigger: "click",
                            },
                        ],
                    },
                    {
                        label: "联系电话",
                        prop: "phone",
                        search: true,
                        span: 24,
                        editDisplay: true,
                        addDisplay: true,
                        rules: [
                            {
                                required: true,
                                message: "请录入联系电话",
                                trigger: "click",
                            },
                        ],
                    },
                    {
                        label: "邮箱",
                        prop: "email",
                        span: 24,
                        editDisplay: true,
                        addDisplay: true,
                    },
                    {
                        label: "所属运维单位",
                        prop: "deptName",
                        span: 12,
                        addDisplay: false,
                        editDisabled: true,
                        rules: [
                            {
                                required: true,
                                message: "请录入单位名称",
                                trigger: "click",
                            },
                        ],
                    }
                    ,
                    {
                        label: "所属运维单位",
                        prop: "deptId",
                        span: 12,
                        hide: true,
                        viewDisplay: false,
                        editDisplay: false,
                        type: "select",
                        addDisabled: false,
                        props: {
                            label: "deptName",
                            value: "id"
                        },
                        dicUrl: "/api/galaxy-business/baseinfo/org/list",
                        rules: [
                            {
                                required: true,
                                message: "请选择运维单位",
                                trigger: "click",
                            },
                        ],
                    },
                ],
            },
            data: [],
        };
    },
    computed: {
        // ...mapGetters(["userInfo", "permission"]),
        permissionList() {
            return {
                // addBtn: this.vaildData(this.permission.docCategory_add, false),
                // viewBtn: this.vaildData(this.permission.docCategory_view, false),
                // delBtn: this.vaildData(this.permission.docCategory_delete, false),
                // editBtn: this.vaildData(this.permission.docCategory_edit, false),
            };
        },
        ids() {
            let ids = [];
            this.selectionList.forEach((ele) => {
                ids.push(ele.id);
            });
            return ids.join(",");
        },
    },
    mounted() { },
    created() {
    },
    methods: {
        rowSave(row, done, loading) {
            add(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowUpdate(row, index, done, loading) {
            update(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowDel(row) {
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(row.id);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                });
        },
        searchReset() {
            this.query = {};
            this.onLoad(this.page);
        },
        searchChange(params, done) {
            this.query = params;
            this.page.currentPage = 1;
            this.onLoad(this.page, params);
            done();
        },
        selectionChange(list) {
            this.selectionList = list;
        },
        selectChange(item) {
            console.log(item)
        },
        selectionClear() {
            this.selectionList = [];
            this.$refs.crud.toggleSelection();
        },
        handleDelete() {
            if (this.selectionList.length === 0) {
                this.$message.warning("请选择至少一条数据");
                return;
            }
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(this.ids);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    this.$refs.crud.toggleSelection();
                });
        },
        beforeOpen(done, type) {
            if (["edit", "view"].includes(type)) {
                getDetail(this.form.id).then((res) => {
                    this.form = res.data.data;
                });
            }
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        onLoad(page, params = {}) {
            this.loading = true;
            getPage(
                page.currentPage,
                page.pageSize,
                Object.assign(params, this.query)
            ).then((res) => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
                this.selectionClear();
            });
        },
    },
};
</script>
